package com.aliyun.iotx.linkvisual.app;

import android.Manifest;
import android.app.Activity;
import android.app.ListActivity;
import android.content.ComponentName;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.support.v4.app.ActivityCompat;
import android.view.View;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.SimpleAdapter;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * @Author: EverettLi.ll
 * @Date: 12/6/18
 * @Description:
 **/
public class MainActivity extends ListActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        SimpleAdapter adapter = new SimpleAdapter(this, getActivityList(), R.layout.list_row,
                new String[]{"title"},
                new int[]{R.id.title});
        setListAdapter(adapter);
    }


    @Override
    protected void onListItemClick(ListView listView, View v, int position, long id) {
        ListAdapter listAdapter = listView.getAdapter();
        Object selectItemObj = listAdapter.getItem(position);
        HashMap<String, Object> itemMap = (HashMap<String, Object>) selectItemObj;
        ActivityInfo activityInfo = (ActivityInfo) itemMap.get("activityInfo");
        Intent intent = new Intent();
        intent.setComponent(new ComponentName(activityInfo.packageName, activityInfo.name));
        startActivity(intent);
    }

    List<HashMap<String, Object>> getActivityList() {
        PackageManager pm = this.getPackageManager();
        PackageInfo info = null;
        try {
            info = pm.getPackageInfo(getApplicationContext().getPackageName(), PackageManager.GET_ACTIVITIES);
        } catch (PackageManager.NameNotFoundException e) {
            e.printStackTrace();
        }
        List<HashMap<String, Object>> ret = new ArrayList<>();
        ActivityInfo[] list = info.activities;
        for (ActivityInfo activityInfo : list) {
            if (!activityInfo.name.contains("Player")) {
                continue;
            }
            HashMap<String, Object> map = new HashMap<>();
            map.put("title", activityInfo.loadLabel(pm).toString());
            map.put("activityInfo", activityInfo);
            ret.add(map);
        }
        return ret;
    }

    public static void verifyStoragePermissions(Activity activity) {

        try {
            //检测是否有写的权限
            int permission = ActivityCompat.checkSelfPermission(activity,
                    "android.permission.WRITE_EXTERNAL_STORAGE");
            if (permission != PackageManager.PERMISSION_GRANTED) {
                // 没有写的权限，去申请写的权限，会弹出对话框
                ActivityCompat.requestPermissions(activity, new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE},
                        1);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
