package com.aliyun.iotx.linkvisual.app;

import android.content.Context;
import android.support.multidex.MultiDexApplication;

import com.squareup.leakcanary.LeakCanary;
import com.squareup.leakcanary.RefWatcher;


/**
 * @Author: EverettLi.ll
 * @Date: 11/5/18
 * @Description:
 **/
public class MyAppication extends MultiDexApplication {

    private RefWatcher refWatcher;

    public static RefWatcher getRefWatcher(Context context) {
        MyAppication application = (MyAppication) context.getApplicationContext();
        return application.refWatcher;
    }

    protected void setupLeakCanary() {
        if (LeakCanary.isInAnalyzerProcess(this)) {
            // This process is dedicated to LeakCanary for heap analysis.
            // You should not init your app in this process.
            return;
        }
        refWatcher = LeakCanary.install(this);
    }

    @Override
    public void onCreate() {
        super.onCreate();
        setupLeakCanary();
    }
}
